<template>
  <div class="movie">
    <img :src="movie.backdrop_path" :alt="movie.original_title" class="movie__poster">
    <div class="movie__data">
      <div class="left">
        <img :src="movie.poster_path" alt="">
      </div>
      <div class="right">
        <div class="title">
          <h1>{{ movie.original_title }}</h1>
          <span>
            Release {{ movie.release_date }}
            <ion-icon name="warning-outline" v-if="movie.adult"></ion-icon>
            <ion-icon name="people-outline" v-else></ion-icon>
          </span>
          <div class="genres">
            <span v-for="(genre, index) in movie.genres" :key="index">
              {{ genre.name }}
            </span>
          </div>
        </div>
        <div class="info">
          <p>{{ movie.overview }}</p>
        </div>
        <div class="none">
          <div class="none__popularity yellow">
            <ion-icon name="star-outline"></ion-icon>
            <h3>{{ movie.popularity }}</h3>
          </div>
          <div class="none__popularity red">
            <ion-icon name="heart-outline"></ion-icon>
            <h3>{{ movie.vote_average }}</h3>
          </div>
        </div>
        <div class="gallery">
          <img :src="movie.backdrop_path" alt="">
          <img :src="movie.backdrop_path" alt="">
          <img :src="movie.backdrop_path" alt="">
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ApiService from "../services/api.service";
import Movie from "../models/movie";
import { useRoute } from "vue-router";

export default {
  name: "Movie",
  data() {
    return {
      movie: Movie
    }
  },
  async mounted() {
    document.title = `Movie | `;
    const route = useRoute();
    const { data } = await ApiService.getMovie(route.params.id);
    document.title = `Movie | ${data.original_title}`;
    let object = {};
    object = data;
    this.movie = new Movie(object);
    console.log(this.movie);
  }
}
</script>

<style lang="scss">
.movie {
  position: relative;

  &__poster {
    width: 100%;
    height: 50vh;
    object-fit: cover;
    filter: blur(50px);
  }

  &__data {
    padding: 20px 80px;
    position: absolute;
    top: 10px;
    left: 10px;
    display: flex;

    .left {
      flex: 0.3;

      img {
        width: 100%;
        object-fit: cover;
        box-shadow:
          0 2.8px 2.2px rgba(0, 0, 0, 0.034),
          0 6.7px 5.3px rgba(0, 0, 0, 0.048),
          0 12.5px 10px rgba(0, 0, 0, 0.06),
          0 22.3px 17.9px rgba(0, 0, 0, 0.072),
          0 41.8px 33.4px rgba(0, 0, 0, 0.086),
          0 100px 80px rgba(0, 0, 0, 0.12)
        ;
      }
    }

    .right {
      flex: 0.7;
      display: flex;
      flex-direction: column;
      margin-left: 20px;

      .title {
        h1 {
          font-size: 40px;
        }
        span {
          font-size: 10px;
          display: flex;
          align-items: center;

          ion-icon {
            margin-left: 10px;
            font-size: 20px;
          }
        }

        .genres {
          display: flex;
          align-items: center;

          span {
            padding: 4px 10px;
            background-color: #000;
          }
        }
      }

      .info {
        margin: 20px 0;

        p {
          font-size: 18px;
        }
      }

      .none {
        display: flex;
        margin: 20px 0;

        &__popularity {
          display: flex;
          align-items: center;
          padding: 14px;
          border-radius: 6px;
          margin-right: 20px;
        }

        .red {
          background-color: rgb(119, 0, 255);
        }

        .yellow {
          background-color: rgb(236, 187, 52);
        }
      }

      .gallery {
        display: grid;
        grid-gap: 25px;
        gap: 25px;
        grid-template-columns: repeat(3, minmax(0, 1fr));

        img {
          width: 100%;
          object-fit: cover;
          box-shadow:
            0 2.8px 2.2px rgba(0, 0, 0, 0.034),
            0 6.7px 5.3px rgba(0, 0, 0, 0.048),
            0 12.5px 10px rgba(0, 0, 0, 0.06),
            0 22.3px 17.9px rgba(0, 0, 0, 0.072),
            0 41.8px 33.4px rgba(0, 0, 0, 0.086),
            0 100px 80px rgba(0, 0, 0, 0.12)
          ;
        }
      }
    }
  }
}
</style>